import java.io.*;
import java.math.*;
import java.util.*;

public class water_af implements Runnable {
	public static void main(String[] args) {
		new Thread(new water_af()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			br = new BufferedReader(new FileReader("water.in"));
			out = new PrintWriter("water.out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				throw new Error("Enexpected end of file");
			}
		}
		return st.nextToken();
	}

	void myAssert(boolean e, String msg) {
		if (!e) {
			throw new Error(msg);
		}
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	
	final int MAX = (int)1e+9;
	void solve() throws IOException {
		int n = nextInt();
		myAssert(1 <= n && n <= 100000, "n out of bounds exception");
		int k = nextInt();
		myAssert(1 <= k && k <= MAX, "k out of bounds exception");
		int[] a = new int[n];
		for (int i = 0; i < n; ++i) {
			a[i] = nextInt();
			myAssert(1 <= a[i] && a[i] <= MAX, "a[" + i + "] out of bounds exception");
		}
		Arrays.sort(a);
		if (a[n - 1] > k) {
			out.println("Impossible");
			return;
		}
		int ans = 0;
		int l = 0;
		int r = n - 1;
		while (l <= r) {
			++ans;
			if (a[l] + a[r] <= k) {
				++l;
			}
			--r;
		}
		out.println(ans);
	}
}
